----------------------------------------------------------------------------
-- @Author: ViperGTS96-----------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

bigfootMotorControl = {};


function bigfootMotorControl.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Washable, specializations)
	and SpecializationUtil.hasSpecialization(Motorized, specializations)
	and SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

if GS_IS_CONSOLE_VERSION then return; end;

function bigfootMotorControl.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", bigfootMotorControl);
end;

function bigfootMotorControl:onPostLoad(savegame)
	if bigfootMotorControl.maxSpeed == nil then
		local configKey = "vehicle.motorized.motorConfigurations.motorConfiguration"
		bigfootMotorControl.maxSpeed = Utils.getNoNil(getXMLFloat(self.xmlFile, string.format(configKey.."(%d).motor#maxForwardSpeed",0)),200);
	end;
	self:getMotor().getRequiredMotorRpmRange = Utils.overwrittenFunction(VehicleMotor.getRequiredMotorRpmRange, bigfootMotorControl.getRequiredMotorRpmRange);
end;

function bigfootMotorControl:getRequiredMotorRpmRange()
	local motorPtoRpm = math.min(PowerConsumer.getMaxPtoRpm(self.vehicle) * self.ptoMotorRpmRatio, self.maxRpm);

	if motorPtoRpm ~= 0 then
		return motorPtoRpm, motorPtoRpm;
	end;

	local limitedSpeed = self:getSpeedLimit();
	local cruiseControl = self.vehicle.spec_drivable.cruiseControl;
	local speedIsLimited = (self.vehicle.spec_drivable:getAccelerationAxis() > 0) and (limitedSpeed < bigfootMotorControl.maxSpeed);
	local ccIsOn = cruiseControl.state > 0;
	if speedIsLimited or ccIsOn then
		limitedSpeed = math.min(limitedSpeed,cruiseControl.speed);
		local motorSpeedRatio = (limitedSpeed+100) / (bigfootMotorControl.maxSpeed+100);
		motorSpeedRatio = motorSpeedRatio*(motorSpeedRatio*(2-motorSpeedRatio));
		local motorLoad = self.vehicle.spec_motorized.smoothedLoadPercentage;
		motorLoad = math.max(motorLoad-0.5,0)+1;
		motorSpeedRatio = math.min(motorSpeedRatio*motorLoad,1);
		local motorSpeed = self.maxRpm * motorSpeedRatio;
		if motorSpeed <= (self.equalizedMotorRpm+100) then
			return motorSpeed, motorSpeed;
		end;
	end;

	return self.minRpm, self.maxRpm;
end;