----------------------------------------------------------------------------
-- @Author: ViperGTS96-----------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

bigfootSteering = {};
bigfootSteering.input = Input.KEY_lshift;

function bigfootSteering.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Washable, specializations)
		and SpecializationUtil.hasSpecialization(Motorized, specializations)
		and SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

if GS_IS_CONSOLE_VERSION then return; end;

function bigfootSteering.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", bigfootSteering);
end;

function bigfootSteering:onLoad(savegame)
	if not GS_MULTIPLAYER then
		if self.spec_crabSteering ~= nil then
			self.updateSteeringAngle = Utils.overwrittenFunction(CrabSteering.updateSteeringAngle, bigfootSteering.updateSteeringAngle);
		end;
	end;
end;

function bigfootSteering:updateSteeringAngle(superFunc, wheel, dt, steeringAngle)
    local spec = self.spec_crabSteering;
    local specWheels = self.spec_wheels;
    local specDriveable = self.spec_drivable;
    if spec.stateMax == 0 then
        return steeringAngle;
    end;
    local currentMode = spec.steeringModes[spec.state];
    if currentMode.wheels == nil or table.getn(currentMode.wheels) == 0 then
        return steeringAngle;
    end;
    for _, wheelProperties in pairs(currentMode.wheels) do
        if specWheels.wheels[wheelProperties.wheelIndex] == wheel then
            local rotScale = math.min(1.0/(self.lastSpeed*specDriveable.speedRotScale+specDriveable.speedRotScaleOffset), 1);
            local delta = dt*0.001*self.autoRotateBackSpeed*rotScale * spec.toggleSpeedFactor;
            if wheel.steeringOffset < wheelProperties.offset then
                wheel.steeringOffset = math.min(wheelProperties.offset, wheel.steeringOffset + delta);
            elseif wheel.steeringOffset > wheelProperties.offset then
                wheel.steeringOffset = math.max(wheelProperties.offset, wheel.steeringOffset - delta);
            end;
            if not wheelProperties.locked then
                local rotSpeed;
                if self.rotatedTime > 0 then
                    rotSpeed = (wheel.rotMax - wheel.steeringOffset) / self.wheelSteeringDuration;
                    if wheel.rotSpeedBackUp < 0 then
                        rotSpeed = (wheel.rotMin - wheel.steeringOffset) / self.wheelSteeringDuration;
                    end;
                else
                    rotSpeed = -(wheel.rotMin - wheel.steeringOffset) / self.wheelSteeringDuration;
                    if wheel.rotSpeedBackUp < 0 then
                        rotSpeed = -(wheel.rotMax - wheel.steeringOffset) / self.wheelSteeringDuration;
                    end;
                end;
                if wheel.rotSpeed < wheel.rotSpeedBackUp then
                    wheel.rotSpeed = math.min(wheel.rotSpeedBackUp, wheel.rotSpeed + delta);
                elseif wheel.rotSpeed > wheel.rotSpeedBackUp then
                    wheel.rotSpeed = math.max(wheel.rotSpeedBackUp, wheel.rotSpeed - delta);
                end;
                local f = wheel.rotSpeed / wheel.rotSpeedBackUp;
                steeringAngle = wheel.steeringOffset + (self.rotatedTime * f * rotSpeed);
            else
                if wheel.steeringAngle > wheel.steeringOffset or steeringAngle > wheel.steeringOffset then
                    steeringAngle = math.max(wheel.steeringOffset, math.min(wheel.steeringAngle, steeringAngle) - delta);
                elseif wheel.steeringAngle < wheel.steeringOffset or steeringAngle < wheel.steeringOffset then
                    steeringAngle = math.min(wheel.steeringOffset, math.max(wheel.steeringAngle, steeringAngle) + delta);
                end;
                if steeringAngle == wheel.steeringOffset then
                    wheel.rotSpeed = 0;
                else
                    if wheel.rotSpeed < 0 then
                        wheel.rotSpeed = math.min(0, wheel.rotSpeed + delta);
                    elseif wheel.rotSpeed > 0 then
                        wheel.rotSpeed = math.max(0, wheel.rotSpeed - delta);
                    end;
                end;
            end;
            steeringAngle = MathUtil.clamp(steeringAngle, wheel.rotMin, wheel.rotMax);
			if Input.isKeyPressed(bigfootSteering.input) then
				if spec.state == 1 then
					if wheel == specWheels.wheels[3] or wheel == specWheels.wheels[4] then
						steeringAngle = steeringAngle * -1;
					end;
				end;
			end;
            break;
        end;
    end;
    return steeringAngle;
end;